#include<bits/stdc++.h>
#define LL long long
#define int long long
using namespace std;
inline LL read(){
	LL res=0,fl=1;
	char ch=getchar();
	while(!(ch>='0' && ch<='9')){
		if(ch=='-')fl=-1;
		ch=getchar();
	}
	while(ch>='0' && ch<='9')res=res*10+ch-'0',ch=getchar();
	return res*fl;
}
const LL N=5e5+5,M=1e6+5,mod=1e9+7;
int n,m,rt,cnt=0,top=0;
int dfn[N],low[N],st[N],fa[N],si[N],cnte[N],tmp[2];
LL f[N][3],pow2[N],d[N][2];
struct Edge{
	int v,id;
};
struct wEdge{
	int x,y;
}a[M];
vector<Edge> e[N];
inline void Tarjan(int x,int d){
	dfn[x]=low[x]=++cnt;
	st[++top]=x;
	for(int i=0;i<(int)e[x].size();i++){
		int y=e[x][i].v,id=e[x][i].id;
		if(id==d)continue;
		if(!dfn[y]){
			Tarjan(y,id);
			low[x]=min(low[x],low[y]);
		}
		else low[x]=min(low[x],dfn[y]);
	}
	if(dfn[x]==low[x]){
		int z;
		while(z=st[top--]){
			fa[z]=x;
			si[x]++;
			if(z==x)break;
		}
	}
}
//inline void Tree_dp(int x,int fat){
//	f[x][0]=d[x][0];
//	f[x][1]=d[x][1]+d[x][0];
//	for(int i=0;i<e[x].size();i++){
//		int y=e[x][i].v;
//		if(y!=fat){
//			Tree_dp(y,x);
//			f[x][0]*=f[y][0]*2%mod;
//			f[x][1]*=(f[y][0]*2+f[y][1])%mod;
//			f[x][0]%=mod,f[x][1]%=mod;
//		}
//	}
//	f[x][1]-=f[x][0];
//}
inline void Tree_dp(int x,int fat){
	f[x][0]=d[x][0];
	f[x][1]=d[x][0]+d[x][1];
	f[x][2]=0;
	int tmp[2];
	tmp[0]=tmp[1]=1;
	int son=0;
	for(int i=0;i<e[x].size();i++){
		int y=e[x][i].v;
		if(y!=fat){
			Tree_dp(y,x);
			son++;
			f[x][0]=f[x][0]*f[y][0]%mod*2%mod;
			f[x][1]=f[x][1]*((f[y][0]*2+f[y][1])%mod)%mod;
			f[x][2]=(f[x][2]+f[y][2]*2+f[y][1]*2)%mod;
			tmp[0]=tmp[0]*f[y][1]*2%mod;
			tmp[1]=tmp[1]*f[y][1]%mod;
		}
	}
	if(son==1)f[x][2]=f[x][2]*500000004%mod;
	f[x][1]=(f[x][1]-f[x][0]+mod)%mod;
//	f[x][2]+=tmp[0]-tmp[1];
	f[x][2]=f[x][2]*d[x][0]%mod;
}
inline void Init(){
	pow2[0]=1;
	for(int i=1;i<=n;i++){
		pow2[i]=pow2[i-1]*2%mod;
	}
}
inline void dfs(int x,int fat){
	if(e[x].size()>1){
		rt=x;
	}
	for(int i=0;i<e[x].size();i++){
		int y=e[x][i].v;
		if(y!=fat){
			dfs(y,x);
		}
	}
}
int p[N],ans=0;
bool chs[N],che[N];
struct EEdge{
	int x,y;
}ee[N];
inline int find(int x){
	if(p[x]==x)return x;
	return p[x]=find(p[x]);
}
inline bool Graph(int id){
	for(int i=1;i<=n;i++)p[i]=i;
	for(int i=1;i<=m;i++){
		if(i==id)continue;
		int x=ee[i].x,y=ee[i].y;
		int px=find(x),py=find(y);
		p[px]=py;
	}
	int po=0;
	for(int i=1;i<=n;i++){
		if(chs[i]){
			if(!po)po=find(i);
			else if(po!=find(i))return 1;
		}
	}
	if(!po)return 1;
	
	return 0;
}
inline int Check(){
	bool fl=0;
	for(int i=1;i<=n;i++)
		if(chs[i])fl=1;
	if(!fl)return 0;
	for(int i=1;i<=m;i++){
		if(che[i])continue;
		if(Graph(i))return 0;
	}
	return 1;
}
inline void dfs2(int x){
	if(x>m){
		int tmp=Check();
		ans+=tmp;
		return;
	}
	che[x]=1;
	dfs2(x+1);
	che[x]=0;
	dfs2(x+1);
}
inline void dfs1(int x){
	if(x>n){
		dfs2(1);
		return;
	}
	chs[x]=1;
	dfs1(x+1);
	chs[x]=0;
	dfs1(x+1);
}
inline void Subtask1(){
	for(int i=1;i<=m;i++){
		int x,y;
		x=read(),y=read();

		ee[i]={x,y};
	}
	dfs1(1);
	cout<<ans<<'\n';
}
signed main(){
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	n=read(),m=read();
	if(n<=8){
		Subtask1();
		return 0;
	}
	Init();
	for(int i=1;i<=m;i++){
		int x,y;
		x=read(),y=read();
		a[i]={x,y};
		e[x].push_back({y,i});
		e[y].push_back({x,i});
	}
	Tarjan(1,0);
	for(int i=1;i<=n;i++)e[i].clear();
	for(int i=1;i<=m;i++){
		int x,y;
		x=a[i].x,y=a[i].y;
		x=fa[x],y=fa[y];
		if(x==y){
			cnte[x]++;
			continue;
		}
		e[x].push_back({y,1});
		e[y].push_back({x,1});
	}
	for(int i=1;i<=n;i++){
		d[i][1]=pow2[cnte[i]]*((pow2[si[i]]-1+mod)%mod)%mod;
		d[i][0]=pow2[cnte[i]];
	}
	rt=fa[1];
	dfs(fa[1],0);

	Tree_dp(rt,0);
	cout<<f[rt][1]+f[rt][2]<<'\n';
	return 0;
}
